Codeforces 983E NN country 思维 (看题解)

NN country

是1175E的加强树上版本, 大致思路是一样的。。

难点在于判断两个点是否被同一条线覆盖。。 居然没想出来。

我们先把所有点对都离线,对于点对(u, v) 我们dfs到 u 的时候 记录一下v子树的和为 t1,

然后把所有在 u 的线段的另一端 + 1, 向子树递归, 回溯的时候再求一下 v 子树的和为 t2

只要判断t1 是否等于 t2, 就知道有没有一条线段同时覆盖u,v。

#include<bits/stdc++.h>
#define LL long long
#define LD long double
#define ull unsigned long long
#define fi first
#define se second
#define mk make_pair
#define PLL pair<LL, LL>
#define PLI pair<LL, int>
#define PII pair<int, int>
#define SZ(x) ((int)x.size())
#define ALL(x) (x).begin(), (x).end()
#define fio ios::sync_with_stdio(false); cin.tie(0);

using namespace std;

const int N = 2e5 + 7;
const int inf = 0x3f3f3f3f;
const LL INF = 0x3f3f3f3f3f3f3f3f;
const int mod = 998244353;
const double eps = 1e-8;
const double PI = acos(-1);

template<class T, class S> inline void add(T& a, S b) {a += b; if(a >= mod) a -= mod;}
template<class T, class S> inline void sub(T& a, S b) {a -= b; if(a < 0) a += mod;}
template<class T, class S> inline bool chkmax(T& a, S b) {return a < b ? a = b, true : false;}
template<class T, class S> inline bool chkmin(T& a, S b) {return a > b ? a = b, true : false;}

int n, m, q;
int in[N], ot[N], idx;
int pa[N][20], depth[N];
int go[N][20];
int ans[N];

vector<int> G[N];
vector<int> seg[N];
vector<PII> qus[N];

struct BIT {
    int a[N];
    void modify(int x, int v) {
        for(int i = x; i < N; i += i & -i) a[i] += v;
    }
    int sum(int x) {
        int ans = 0;
        for(int i = x; i; i -= i & -i) ans += a[i];
        return ans;
    }
    int query(int L, int R) {
        if(L > R) return 0;
        return sum(R) - sum(L - 1);
    }
} bit;

void dfs(int u, int fa) {
    depth[u] = depth[fa] + 1;
    pa[u][0] = fa;
    in[u] = ++idx;
    for(int i = 1; i < 20; i++)
        pa[u][i] = pa[pa[u][i - 1]][i - 1];
    for(auto &v : G[u]) {
        if(v == fa) continue;
        dfs(v, u);
    }
    ot[u] = idx;
}
int getLca(int u, int v) {
    if(depth[u] < depth[v]) swap(u, v);
    int dis = depth[u] - depth[v];
    for(int i = 19; i >= 0; i--)
        if(dis >> i & 1) u = pa[u][i];
    if(u == v) return u;
    for(int i = 19; i >= 0; i--)
        if(pa[u][i] != pa[v][i])
            u = pa[u][i], v = pa[v][i];
    return pa[u][0];
}

void dfs2(int u, int fa) {
    for(auto &v : G[u]) {
        if(v == fa) continue;
        dfs2(v, u);
        if(depth[go[v][0]] < depth[go[u][0]]) {
            go[u][0] = go[v][0];
        }
    }
}

void dfs3(int u, int fa) {
    vector<int> preVal(SZ(qus[u]));
    for(int i = 0; i < SZ(qus[u]); i++)
        preVal[i] = bit.query(in[qus[u][i].fi], ot[qus[u][i].fi]);
    for(auto &v : seg[u]) bit.modify(in[v], 1);
    for(auto &v : G[u]) {
        if(v == fa) continue;
        dfs3(v, u);
    }
    for(int i = 0; i < SZ(qus[u]); i++) {
        if(bit.query(in[qus[u][i].fi], ot[qus[u][i].fi]) == preVal[i]) ans[qus[u][i].se] += 2;
        else ans[qus[u][i].se]++;
    }
}

int main() {
    scanf("%d", &n);
    for(int i = 1; i <= n; i++) go[i][0] = i;
    for(int i = 2; i <= n; i++) {
        int fa; scanf("%d", &fa);
        G[fa].push_back(i);
    }
    dfs(1, 0);
    scanf("%d", &m);
    for(int i = 1; i <= m; i++) {
        int u, v;
        scanf("%d%d", &u, &v);
        int lca = getLca(u, v);
        if(depth[lca] < depth[go[u][0]]) go[u][0] = lca;
        if(depth[lca] < depth[go[v][0]]) go[v][0] = lca;
        seg[u].push_back(v);
        seg[v].push_back(u);
    }
    dfs2(1, 0);
    for(int j = 1; j < 20; j++)
        for(int i = 1; i <= n; i++)
            go[i][j] = go[go[i][j - 1]][j - 1];
    scanf("%d", &q);
    for(int o = 1; o <= q; o++){
        int u, v;
        scanf("%d%d", &u, &v);
        int lca = getLca(u, v);
        if(lca == u) {
            for(int i = 19; i >= 0; i--)
                if(depth[go[v][i]] > depth[lca])
                    v = go[v][i], ans[o] += 1 << i;
            if(depth[go[v][0]] > depth[lca]) ans[o] = -1;
            else ans[o]++;
        } else if(lca == v) {
            for(int i = 19; i >= 0; i--)
                if(depth[go[u][i]] > depth[lca])
                    u = go[u][i], ans[o] += 1 << i;
            if(depth[go[u][0]] > depth[lca]) ans[o] = -1;
            else ans[o]++;
        } else {
            for(int i = 19; i >= 0; i--)
                if(depth[go[v][i]] > depth[lca])
                    v = go[v][i], ans[o] += 1 << i;
            for(int i = 19; i >= 0; i--) {
                if(depth[go[u][i]] > depth[lca]) {
                    u = go[u][i], ans[o] += 1 << i;
                }
            }
            if(depth[go[u][0]] > depth[lca] || depth[go[v][0]] > depth[lca]) ans[o] = -1;
            else qus[u].push_back(mk(v, o));
        }
    }
    dfs3(1, 0);
    for(int i = 1; i <= q; i++) printf("%d\n", ans[i]);
    return 0;
}

/*
*/

原文地址:https://www.cnblogs.com/CJLHY/p/10989394.html

时间: 2024-11-02 23:43:20

Codeforces 983E NN country 思维 (看题解)的相关文章

Codeforces 200A Cinema 并查集 + 思维 (看题解)

Cinema 感觉这个题好神啊... 首先如果 n 比 m 大, 我们先旋转90度. 我们要加入一个(x, y)的时候, 我们枚举答案所在的行离 x 的距离 g , 然后对于x + g 行来说 我们找到(x + g, y)左边的第一个和右边的第一个未被占的位置,更新答案, 如果 g > 答案 退出. 左边和右边第一个未被占的可以用并查集维护, 把连续占了的并成一个联通块, 维护最小值和最大值. 对于 2000 * 2000的图来说, 对于每一次, 最多sqrt( n )就能找到答案, 因为最坏情

983E - NN country

http://codeforces.com/problemset/problem/983/E 题意:给定一棵树,给m个公交车路线,即从u到v可直达不用换乘,给q次查询,问从u,v最少需要多少次换乘 题解:考虑到查询操作我们可以分成两部分u->lca(u,v)->v,对于u->lca这段路我们找到t,即从t->lca只需要一次换乘,对于右边路径,我们需要找到一个点z,使得t->z有一次换乘的路径(通过主席树来维护t的子树和z的子树之间是否有直达路线),满足单调性,所以二分查找最

Codeforces 750E New Year and Old Subsequence 线段树 + dp (看题解)

New Year and Old Subsequence 第一感觉是离线之后分治求dp, 但是感觉如果要把左边的dp值和右边的dp值合起来, 感觉很麻烦而且时间复杂度不怎么对.. 然后就gun取看题解了, 用线段树维护dp的值, 然后区间合并求答案. 每个节点保存dp[ i ][ j ]表示, 把当前管理的区间删到 s{2017}中的 s[ i + 1 ] - s[ j - 1 ],最少删几个, 然后合并的时候5 ^ 3合并. #include<bits/stdc++.h> #define L

【codeforces #292(div 1)】ABC题解

A. Drazil and Factorial time limit per test 2 seconds memory limit per test 256 megabytes input standard input output standard output Drazil is playing a math game with Varda. Let's define  for positive integer x as a product of factorials of its dig

Codeforces Round #483 (Div. 1) 简要题解

来自FallDream的博客,未经允许,请勿转载,谢谢. 为了证明一下我又来更新了,写一篇简要的题解吧. 这场比赛好像有点神奇,E题莫名是道原题,导致有很多选手直接过掉了(Claris 表演24s过题).然而D题比E题要难一些,分还少. A. Finite or not? 先把\(\frac{p}{q}\)约成最简分数,然后就是要判断是否\(q\)的所有质因数都是\(b\)的质因数. 每次取\(g=gcd(b,q)\),并尽可能的让\(q\)除\(g\),最后判断\(q\)是否是1即可. 还有一

【codeforces #286(div 2)】ABCD题解

这次rank23~又回到紫名啦~ A.枚举插入的位置和插入的字符,暴力判断即可. #include <iostream> #include <cmath> #include <cstdio> #include <cstdlib> #include <algorithm> #include <cstring> #include <string> using namespace std; string S; int s[20]

# Codeforces Round #529(Div.3)个人题解

Codeforces Round #529(Div.3)个人题解 前言: 闲来无事补了前天的cf,想着最近刷题有点点怠惰,就直接一场cf一场cf的刷算了,以后的题解也都会以每场的形式写出来 A. Repeating Cipher 传送门 题意:第一个字母写一次,第二个字母写两次,依次递推,求原字符串是什么 题解:1.2.3.4,非常明显的d=1的等差数列,所以预处理一个等差数列直接取等差数列的每一项即可 代码: #include<bits/stdc++.h> using namespace s

Codeforces 1041F Ray in the tube (看题解)

Ray in the tube 感觉是套路题.. 如果确定一个差值x我们如何取确定答案呢, 我们把a[ i ] -> a[ i ] % (2 * x), 把b[ i ] -> (b[ i ] + k) % (2 * x), 值相同的都能同时射到. 同时我们能发现, 对于一个差值x如果它有奇数因子, 把它除掉之后会更优, 所以我们要check的x只有2的幂次. #include<bits/stdc++.h> #define LL long long #define fi first

Codeforces 460D Little Victor and Set(看题解)

Little Victor and Set 其他都很好求, 只有k == 3的时候很难受.. 我们找到第一个不大于l的 t, 答案为 l, 3 * t, (3 * t) ^ l 感觉好像是对的, 感觉又不会证明, 啊, 我好菜啊. #include<bits/stdc++.h> #define LL long long #define fi first #define se second #define mk make_pair #define PLL pair<LL, LL> #